import { Injectable } from '@angular/core';
import { Http, Response, Headers, RequestOptions } from '@angular/http';
import { Observable } from 'rxjs/Observable'
import { Token } from '../components/token.component';

import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import 'rxjs/add/observable/throw'

@Injectable()
export class TokenService {

    username: string = 'admin';
    password: string = 'admin';
    url: string = '192.168.100.141:22000';

    constructor(public http: Http) {
        console.log('Hello TokenAuth Provider');
    }

    getToken(): void {
        let response = this.getTokenFromServer();

        response.subscribe(data => {
                console.log(data.value);
            }, err => console.error('Error: ' + err),
            () => console.log('Token received')
        );

    }

    // Check if introduced url is valid
    checkUrl(): boolean {
        return this.url.includes('.');
    }

    // Normalize provide url
    private normalizeUrl(url: string): string {
        return (url.startsWith('http://') ? url : 'http://' + url) + '/api/jwt';
    }

    // Get token from server
    getTokenFromServer(): Observable<Token> {
        let body = 'username=' + this.username + '&password=' + this.password;
        let headers = new Headers({ 'Content-Type':  'application/x-www-form-urlencoded' });
        let options = new RequestOptions({ headers: headers });

        return this.http.post(this.normalizeUrl(this.url), body, options).map(this.extractData).catch(this.handleError);
    }

    // Extract data from http response
    private extractData(response: Response) {
        let body = response.json();
        let token = new Token(body.token);

        return token;
    }

    // Handle error if ocurred
    private handleError(error: any) {
        let msg = error._body;

        return Observable.throw(msg);
    }
}
